diff --git a/src/backend/statistics/dependencies.c b/src/backend/statistics/dependencies.c
index c1c27e67d4..db14e35c86 100644
--- a/src/backend/statistics/dependencies.c
+++ b/src/backend/statistics/dependencies.c
@@ -76,7 +76,7 @@ static double dependency_degree(StatsBuildData *data, int k, AttrNumber *depende
 static bool dependency_is_fully_matched(MVDependency *dependency,
 										Bitmapset *attnums);
 static bool dependency_is_compatible_clause(Node *clause, Index relid,
-											AttrNumber *attnum);
+											AttrNumber *attphysnum);
 static bool dependency_is_compatible_expression(Node *clause, Index relid,
 												List *statlist, Node **expr);
 static MVDependency *find_strongest_dependency(MVDependencies **dependencies,
@@ -604,9 +604,9 @@ dependency_is_fully_matched(MVDependency *dependency, Bitmapset *attnums)
 	 */
 	for (j = 0; j < dependency->nattributes; j++)
 	{
-		int			attnum = dependency->attributes[j];
+		int			attphysnum = dependency->attributes[j];
 
-		if (!bms_is_member(attnum, attnums))
+		if (!bms_is_member(attphysnum, attnums))
 			return false;
 	}
 
@@ -737,10 +737,10 @@ pg_dependencies_send(PG_FUNCTION_ARGS)
  * Only clauses that have the form of equality to a pseudoconstant, or can be
  * interpreted that way, are currently accepted.  Furthermore the variable
  * part of the clause must be a simple Var belonging to the specified
- * relation, whose attribute number we return in *attnum on success.
+ * relation, whose attribute number we return in *attphysnum on success.
  */
 static bool
-dependency_is_compatible_clause(Node *clause, Index relid, AttrNumber *attnum)
+dependency_is_compatible_clause(Node *clause, Index relid, AttrNumber *attphysnum)
 {
 	Var		   *var;
 	Node	   *clause_expr;
@@ -839,7 +839,7 @@ dependency_is_compatible_clause(Node *clause, Index relid, AttrNumber *attnum)
 		ListCell   *lc;
 
 		/* start with no attribute number */
-		*attnum = InvalidAttrNumber;
+		*attphysnum = InvalidAttrNumber;
 
 		foreach(lc, bool_expr->args)
 		{
@@ -853,11 +853,11 @@ dependency_is_compatible_clause(Node *clause, Index relid, AttrNumber *attnum)
 												 relid, &clause_attnum))
 				return false;
 
-			if (*attnum == InvalidAttrNumber)
-				*attnum = clause_attnum;
+			if (*attphysnum == InvalidAttrNumber)
+				*attphysnum = clause_attnum;
 
-			/* ensure all the variables are the same (same attnum) */
-			if (*attnum != clause_attnum)
+			/* ensure all the variables are the same (same attphysnum) */
+			if (*attphysnum != clause_attnum)
 				return false;
 		}
 
@@ -907,7 +907,7 @@ dependency_is_compatible_clause(Node *clause, Index relid, AttrNumber *attnum)
 	if (!AttrNumberIsForUserDefinedAttr(var->varattno))
 		return false;
 
-	*attnum = var->varattno;
+	*attphysnum = var->varattno;
 	return true;
 }
 
@@ -1041,9 +1041,9 @@ clauselist_apply_dependencies(PlannerInfo *root, List *clauses,
 	{
 		for (j = 0; j < dependencies[i]->nattributes; j++)
 		{
-			AttrNumber	attnum = dependencies[i]->attributes[j];
+			AttrNumber	attphysnum = dependencies[i]->attributes[j];
 
-			attnums = bms_add_member(attnums, attnum);
+			attnums = bms_add_member(attnums, attphysnum);
 		}
 	}
 
@@ -1106,7 +1106,7 @@ clauselist_apply_dependencies(PlannerInfo *root, List *clauses,
 	for (i = ndependencies - 1; i >= 0; i--)
 	{
 		MVDependency *dependency = dependencies[i];
-		AttrNumber	attnum;
+		AttrNumber	attphysnum;
 		Selectivity s2;
 		double		f;
 
@@ -1114,14 +1114,14 @@ clauselist_apply_dependencies(PlannerInfo *root, List *clauses,
 		s1 = 1.0;
 		for (j = 0; j < dependency->nattributes - 1; j++)
 		{
-			attnum = dependency->attributes[j];
-			attidx = bms_member_index(attnums, attnum);
+			attphysnum = dependency->attributes[j];
+			attidx = bms_member_index(attnums, attphysnum);
 			s1 *= attr_sel[attidx];
 		}
 
 		/* Original selectivity of the implied attribute */
-		attnum = dependency->attributes[j];
-		attidx = bms_member_index(attnums, attnum);
+		attphysnum = dependency->attributes[j];
+		attidx = bms_member_index(attnums, attphysnum);
 		s2 = attr_sel[attidx];
 
 		/*
@@ -1454,7 +1454,7 @@ dependencies_clauselist_selectivity(PlannerInfo *root,
 	foreach(l, clauses)
 	{
 		Node	   *clause = (Node *) lfirst(l);
-		AttrNumber	attnum;
+		AttrNumber	attphysnum;
 		Node	   *expr = NULL;
 
 		/* ignore clause by default */
@@ -1464,19 +1464,19 @@ dependencies_clauselist_selectivity(PlannerInfo *root,
 		{
 			/*
 			 * If it's a simple column reference, just extract the attnum. If
-			 * it's an expression, assign a negative attnum as if it was a
+			 * it's an expression, assign a negative attphysnum as if it was a
 			 * system attribute.
 			 */
-			if (dependency_is_compatible_clause(clause, rel->relid, &attnum))
+			if (dependency_is_compatible_clause(clause, rel->relid, &attphysnum))
 			{
-				list_attnums[listidx] = attnum;
+				list_attnums[listidx] = attphysnum;
 			}
 			else if (dependency_is_compatible_expression(clause, rel->relid,
 														 rel->statlist,
 														 &expr))
 			{
-				/* special attnum assigned to this expression */
-				attnum = InvalidAttrNumber;
+				/* special attphysnum assigned to this expression */
+				attphysnum = InvalidAttrNumber;
 
 				Assert(expr != NULL);
 
@@ -1486,22 +1486,22 @@ dependencies_clauselist_selectivity(PlannerInfo *root,
 					if (equal(unique_exprs[i], expr))
 					{
 						/* negative attribute number to expression */
-						attnum = -(i + 1);
+						attphysnum = -(i + 1);
 						break;
 					}
 				}
 
 				/* not found in the list, so add it */
-				if (attnum == InvalidAttrNumber)
+				if (attphysnum == InvalidAttrNumber)
 				{
 					unique_exprs[unique_exprs_cnt++] = expr;
 
 					/* after incrementing the value, to get -1, -2, ... */
-					attnum = (-unique_exprs_cnt);
+					attphysnum = (-unique_exprs_cnt);
 				}
 
-				/* remember which attnum was assigned to this clause */
-				list_attnums[listidx] = attnum;
+				/* remember which attphysnum was assigned to this clause */
+				list_attnums[listidx] = attphysnum;
 			}
 		}
 
@@ -1526,39 +1526,39 @@ dependencies_clauselist_selectivity(PlannerInfo *root,
 	 */
 	for (i = 0; i < list_length(clauses); i++)
 	{
-		AttrNumber	attnum;
+		AttrNumber	attphysnum;
 
 		/* ignore incompatible or already estimated clauses */
 		if (list_attnums[i] == InvalidAttrNumber)
 			continue;
 
-		/* make sure the attnum is in the expected range */
+		/* make sure the attphysnum is in the expected range */
 		Assert(list_attnums[i] >= (-unique_exprs_cnt));
 		Assert(list_attnums[i] <= MaxHeapAttributeNumber);
 
-		/* make sure the attnum is positive (valid AttrNumber) */
-		attnum = list_attnums[i] + attnum_offset;
+		/* make sure the attphysnum is positive (valid AttrNumber) */
+		attphysnum = list_attnums[i] + attnum_offset;
 
 		/*
 		 * Either it's a regular attribute, or it's an expression, in which
 		 * case we must not have seen it before (expressions are unique).
 		 *
 		 * XXX Check whether it's a regular attribute has to be done using the
-		 * original attnum, while the second check has to use the value with
+		 * original attphysnum, while the second check has to use the value with
 		 * an offset.
 		 */
 		Assert(AttrNumberIsForUserDefinedAttr(list_attnums[i]) ||
-			   !bms_is_member(attnum, clauses_attnums));
+			   !bms_is_member(attphysnum, clauses_attnums));
 
 		/*
-		 * Remember the offset attnum, both for attributes and expressions.
+		 * Remember the offset attphysnum, both for attributes and expressions.
 		 * We'll pass list_attnums to clauselist_apply_dependencies, which
 		 * uses it to identify clauses in a bitmap. We could also pass the
 		 * offset, but this is more convenient.
 		 */
-		list_attnums[i] = attnum;
+		list_attnums[i] = attphysnum;
 
-		clauses_attnums = bms_add_member(clauses_attnums, attnum);
+		clauses_attnums = bms_add_member(clauses_attnums, attphysnum);
 	}
 
 	/*
@@ -1606,7 +1606,7 @@ dependencies_clauselist_selectivity(PlannerInfo *root,
 			continue;
 
 		/*
-		 * Count matching attributes - we have to undo the attnum offsets. The
+		 * Count matching attributes - we have to undo the attphysnum offsets. The
 		 * input attribute numbers are not offset (expressions are not
 		 * included in stat->keys, so it's not necessary). But we need to
 		 * offset it before checking against clauses_attnums.
@@ -1615,16 +1615,16 @@ dependencies_clauselist_selectivity(PlannerInfo *root,
 		k = -1;
 		while ((k = bms_next_member(stat->keys, k)) >= 0)
 		{
-			AttrNumber	attnum = (AttrNumber) k;
+			AttrNumber	attphysnum = (AttrNumber) k;
 
 			/* skip expressions */
-			if (!AttrNumberIsForUserDefinedAttr(attnum))
+			if (!AttrNumberIsForUserDefinedAttr(attphysnum))
 				continue;
 
 			/* apply the same offset as above */
-			attnum += attnum_offset;
+			attphysnum += attnum_offset;
 
-			if (bms_is_member(attnum, clauses_attnums))
+			if (bms_is_member(attphysnum, clauses_attnums))
 				nmatched++;
 		}
 
@@ -1695,20 +1695,20 @@ dependencies_clauselist_selectivity(PlannerInfo *root,
 					Node	   *expr;
 					int			k;
 					AttrNumber	unique_attnum = InvalidAttrNumber;
-					AttrNumber	attnum;
+					AttrNumber	attphysnum;
 
 					/* undo the per-statistics offset */
-					attnum = dep->attributes[j];
+					attphysnum = dep->attributes[j];
 
 					/*
 					 * For regular attributes we can simply check if it
 					 * matches any clause. If there's no matching clause, we
-					 * can just ignore it. We need to offset the attnum
+					 * can just ignore it. We need to offset the attphysnum
 					 * though.
 					 */
-					if (AttrNumberIsForUserDefinedAttr(attnum))
+					if (AttrNumberIsForUserDefinedAttr(attphysnum))
 					{
-						dep->attributes[j] = attnum + attnum_offset;
+						dep->attributes[j] = attphysnum + attnum_offset;
 
 						if (!bms_is_member(dep->attributes[j], clauses_attnums))
 						{
@@ -1720,20 +1720,20 @@ dependencies_clauselist_selectivity(PlannerInfo *root,
 					}
 
 					/*
-					 * the attnum should be a valid system attnum (-1, -2,
+					 * the attphysnum should be a valid system attphysnum (-1, -2,
 					 * ...)
 					 */
-					Assert(AttributeNumberIsValid(attnum));
+					Assert(AttributeNumberIsValid(attphysnum));
 
 					/*
 					 * For expressions, we need to do two translations. First
-					 * we have to translate the negative attnum to index in
+					 * we have to translate the negative attphysnum to index in
 					 * the list of expressions (in the statistics object).
 					 * Then we need to see if there's a matching clause. The
-					 * index of the unique expression determines the attnum
+					 * index of the unique expression determines the attphysnum
 					 * (and we offset it).
 					 */
-					idx = -(1 + attnum);
+					idx = -(1 + attphysnum);
 
 					/* Is the expression index is valid? */
 					Assert((idx >= 0) && (idx < list_length(stat->exprs)));
@@ -1744,7 +1744,7 @@ dependencies_clauselist_selectivity(PlannerInfo *root,
 					for (k = 0; k < unique_exprs_cnt; k++)
 					{
 						/*
-						 * found a matching unique expression, use the attnum
+						 * found a matching unique expression, use the attphysnum
 						 * (derived from index of the unique expression)
 						 */
 						if (equal(unique_exprs[k], expr))
@@ -1765,7 +1765,7 @@ dependencies_clauselist_selectivity(PlannerInfo *root,
 						break;
 					}
 
-					/* otherwise remap it to the new attnum */
+					/* otherwise remap it to the new attphysnum */
 					dep->attributes[j] = unique_attnum;
 				}
 
@@ -1816,7 +1816,7 @@ dependencies_clauselist_selectivity(PlannerInfo *root,
 	while (true)
 	{
 		MVDependency *dependency;
-		AttrNumber	attnum;
+		AttrNumber	attphysnum;
 
 		/* the widest/strongest dependency, fully matched by clauses */
 		dependency = find_strongest_dependency(func_dependencies,
@@ -1828,8 +1828,8 @@ dependencies_clauselist_selectivity(PlannerInfo *root,
 		dependencies[ndependencies++] = dependency;
 
 		/* Ignore dependencies using this implied attribute in later loops */
-		attnum = dependency->attributes[dependency->nattributes - 1];
-		clauses_attnums = bms_del_member(clauses_attnums, attnum);
+		attphysnum = dependency->attributes[dependency->nattributes - 1];
+		clauses_attnums = bms_del_member(clauses_attnums, attphysnum);
 	}
 
 	/*
diff --git a/src/backend/statistics/extended_stats.c b/src/backend/statistics/extended_stats.c
index ca48395d5c..b11db27812 100644
--- a/src/backend/statistics/extended_stats.c
+++ b/src/backend/statistics/extended_stats.c
@@ -391,31 +391,31 @@ statext_compute_stattarget(int stattarget, int nattrs, VacAttrStats **stats)
 bool
 statext_is_kind_built(HeapTuple htup, char type)
 {
-	AttrNumber	attnum;
+	AttrNumber	attphysnum;
 
 	switch (type)
 	{
 		case STATS_EXT_NDISTINCT:
-			attnum = Anum_pg_statistic_ext_data_stxdndistinct;
+			attphysnum = Anum_pg_statistic_ext_data_stxdndistinct;
 			break;
 
 		case STATS_EXT_DEPENDENCIES:
-			attnum = Anum_pg_statistic_ext_data_stxddependencies;
+			attphysnum = Anum_pg_statistic_ext_data_stxddependencies;
 			break;
 
 		case STATS_EXT_MCV:
-			attnum = Anum_pg_statistic_ext_data_stxdmcv;
+			attphysnum = Anum_pg_statistic_ext_data_stxdmcv;
 			break;
 
 		case STATS_EXT_EXPRESSIONS:
-			attnum = Anum_pg_statistic_ext_data_stxdexpr;
+			attphysnum = Anum_pg_statistic_ext_data_stxdexpr;
 			break;
 
 		default:
 			elog(ERROR, "unexpected statistics type requested: %d", type);
 	}
 
-	return !heap_attisnull(htup, attnum, NULL);
+	return !heap_attisnull(htup, attphysnum, NULL);
 }
 
 /*
@@ -655,7 +655,7 @@ examine_expression(Node *expr, int stattarget)
 
 	/* initialize some basic fields */
 	stats->attr->attrelid = InvalidOid;
-	stats->attr->attnum = InvalidAttrNumber;
+	stats->attr->attphysnum = InvalidAttrNumber;
 	stats->attr->atttypid = stats->attrtypid;
 
 	typtuple = SearchSysCacheCopy1(TYPEOID,
@@ -722,7 +722,7 @@ lookup_var_attr_stats(Relation rel, Bitmapset *attrs, List *exprs,
 
 	stats = (VacAttrStats **) palloc(natts * sizeof(VacAttrStats *));
 
-	/* lookup VacAttrStats info for the requested columns (same attnum) */
+	/* lookup VacAttrStats info for the requested columns (same attphysnum) */
 	while ((x = bms_next_member(attrs, x)) >= 0)
 	{
 		int			j;
@@ -979,7 +979,7 @@ build_attnums_array(Bitmapset *attrs, int nexprs, int *numattrs)
 	j = -1;
 	while ((j = bms_next_member(attrs, j)) >= 0)
 	{
-		int			attnum = (j - nexprs);
+		int			attphysnum = (j - nexprs);
 
 		/*
 		 * Make sure the bitmap contains only user-defined attributes. As
@@ -987,11 +987,11 @@ build_attnums_array(Bitmapset *attrs, int nexprs, int *numattrs)
 		 * ways. Firstly, the bitmap might contain 0 as a member, and secondly
 		 * the integer value might be larger than MaxAttrNumber.
 		 */
-		Assert(AttributeNumberIsValid(attnum));
-		Assert(attnum <= MaxAttrNumber);
-		Assert(attnum >= (-nexprs));
+		Assert(AttributeNumberIsValid(attphysnum));
+		Assert(attphysnum <= MaxAttrNumber);
+		Assert(attphysnum >= (-nexprs));
 
-		attnums[i++] = (AttrNumber) attnum;
+		attnums[i++] = (AttrNumber) attphysnum;
 
 		/* protect against overflows */
 		Assert(i <= num);
@@ -1070,14 +1070,14 @@ build_sorted_items(StatsBuildData *data, int *nitems,
 			Datum		value;
 			bool		isnull;
 			int			attlen;
-			AttrNumber	attnum = attnums[j];
+			AttrNumber	attphysnum = attnums[j];
 
 			int			idx;
 
-			/* match attnum to the pre-calculated data */
+			/* match attphysnum to the pre-calculated data */
 			for (idx = 0; idx < data->nattnums; idx++)
 			{
-				if (attnum == data->attnums[idx])
+				if (attphysnum == data->attnums[idx])
 					break;
 			}
 
@@ -1635,11 +1635,11 @@ statext_is_compatible_clause(PlannerInfo *root, Node *clause, Index relid,
 		else
 		{
 			/* Check the columns referenced by the clause */
-			int			attnum = -1;
+			int			attphysnum = -1;
 
-			while ((attnum = bms_next_member(clause_attnums, attnum)) >= 0)
+			while ((attphysnum = bms_next_member(clause_attnums, attphysnum)) >= 0)
 			{
-				if (pg_attribute_aclcheck(rte->relid, attnum, userid,
+				if (pg_attribute_aclcheck(rte->relid, attphysnum, userid,
 										  ACL_SELECT) != ACLCHECK_OK)
 					return false;
 			}
@@ -2186,7 +2186,7 @@ compute_expr_stats(Relation onerel, double totalrows,
 		{
 			AttributeOpts *aopt =
 			get_attribute_options(stats->attr->attrelid,
-								  stats->attr->attnum);
+								  stats->attr->attphysnum);
 
 			stats->exprvals = exprvals;
 			stats->exprnulls = exprnulls;
diff --git a/src/backend/statistics/mvdistinct.c b/src/backend/statistics/mvdistinct.c
index 6ade5eff78..e8e8682c8a 100644
--- a/src/backend/statistics/mvdistinct.c
+++ b/src/backend/statistics/mvdistinct.c
@@ -373,9 +373,9 @@ pg_ndistinct_out(PG_FUNCTION_ARGS)
 
 		for (j = 0; j < item.nattributes; j++)
 		{
-			AttrNumber	attnum = item.attributes[j];
+			AttrNumber	attphysnum = item.attributes[j];
 
-			appendStringInfo(&str, "%s%d", (j == 0) ? "\"" : ", ", attnum);
+			appendStringInfo(&str, "%s%d", (j == 0) ? "\"" : ", ", attphysnum);
 		}
 		appendStringInfo(&str, "\": %d", (int) item.ndistinct);
 	}
diff --git a/src/backend/utils/adt/acl.c b/src/backend/utils/adt/acl.c
index 772c04155c..0659109257 100644
--- a/src/backend/utils/adt/acl.c
+++ b/src/backend/utils/adt/acl.c
@@ -2444,13 +2444,13 @@ has_any_column_privilege_id_id(PG_FUNCTION_ARGS)
  * has_column_privilege variants
  *		These are all named "has_column_privilege" at the SQL level.
  *		They take various combinations of relation name, relation OID,
- *		column name, column attnum, user name, user OID, or
+ *		column name, column attphysnum, user name, user OID, or
  *		implicit user = current_user.
  *
  *		The result is a boolean value: true if user has the indicated
  *		privilege, false if not.  The variants that take a relation OID
  *		return NULL (rather than throwing an error) if that relation OID
- *		doesn't exist.  Likewise, the variants that take an integer attnum
+ *		doesn't exist.  Likewise, the variants that take an integer attphysnum
  *		return NULL (rather than throwing an error) if there is no such
  *		pg_attribute entry.  All variants return NULL if an attisdropped
  *		column is selected.  These rules are meant to avoid unnecessary
@@ -2464,7 +2464,7 @@ has_any_column_privilege_id_id(PG_FUNCTION_ARGS)
  * Returns 1 if have the privilege, 0 if not, -1 if dropped column/table.
  */
 static int
-column_privilege_check(Oid tableoid, AttrNumber attnum,
+column_privilege_check(Oid tableoid, AttrNumber attphysnum,
 					   Oid roleid, AclMode mode)
 {
 	AclResult	aclresult;
@@ -2473,7 +2473,7 @@ column_privilege_check(Oid tableoid, AttrNumber attnum,
 	/*
 	 * If convert_column_name failed, we can just return -1 immediately.
 	 */
-	if (attnum == InvalidAttrNumber)
+	if (attphysnum == InvalidAttrNumber)
 		return -1;
 
 	/*
@@ -2481,7 +2481,7 @@ column_privilege_check(Oid tableoid, AttrNumber attnum,
 	 * on whether the column even exists, so we need to do it before checking
 	 * table-level privilege.
 	 */
-	aclresult = pg_attribute_aclcheck_ext(tableoid, attnum, roleid,
+	aclresult = pg_attribute_aclcheck_ext(tableoid, attphysnum, roleid,
 										  mode, &is_missing);
 	if (aclresult == ACLCHECK_OK)
 		return 1;
@@ -2530,7 +2530,7 @@ has_column_privilege_name_name_name(PG_FUNCTION_ARGS)
 /*
  * has_column_privilege_name_name_attnum
  *		Check user privileges on a column given
- *		name username, text tablename, int attnum, and text priv name.
+ *		name username, text tablename, int attphysnum, and text priv name.
  */
 Datum
 has_column_privilege_name_name_attnum(PG_FUNCTION_ARGS)
@@ -2584,7 +2584,7 @@ has_column_privilege_name_id_name(PG_FUNCTION_ARGS)
 /*
  * has_column_privilege_name_id_attnum
  *		Check user privileges on a column given
- *		name username, table oid, int attnum, and text priv name.
+ *		name username, table oid, int attphysnum, and text priv name.
  */
 Datum
 has_column_privilege_name_id_attnum(PG_FUNCTION_ARGS)
@@ -2636,7 +2636,7 @@ has_column_privilege_id_name_name(PG_FUNCTION_ARGS)
 /*
  * has_column_privilege_id_name_attnum
  *		Check user privileges on a column given
- *		oid roleid, text tablename, int attnum, and text priv name.
+ *		oid roleid, text tablename, int attphysnum, and text priv name.
  */
 Datum
 has_column_privilege_id_name_attnum(PG_FUNCTION_ARGS)
@@ -2686,7 +2686,7 @@ has_column_privilege_id_id_name(PG_FUNCTION_ARGS)
 /*
  * has_column_privilege_id_id_attnum
  *		Check user privileges on a column given
- *		oid roleid, table oid, int attnum, and text priv name.
+ *		oid roleid, table oid, int attphysnum, and text priv name.
  */
 Datum
 has_column_privilege_id_id_attnum(PG_FUNCTION_ARGS)
@@ -2738,7 +2738,7 @@ has_column_privilege_name_name(PG_FUNCTION_ARGS)
 /*
  * has_column_privilege_name_attnum
  *		Check user privileges on a column given
- *		text tablename, int attnum, and text priv name.
+ *		text tablename, int attphysnum, and text priv name.
  *		current_user is assumed
  */
 Datum
@@ -2792,7 +2792,7 @@ has_column_privilege_id_name(PG_FUNCTION_ARGS)
 /*
  * has_column_privilege_id_attnum
  *		Check user privileges on a column given
- *		table oid, int attnum, and text priv name.
+ *		table oid, int attphysnum, and text priv name.
  *		current_user is assumed
  */
 Datum
@@ -2828,12 +2828,12 @@ convert_column_name(Oid tableoid, text *column)
 {
 	char	   *colname;
 	HeapTuple	attTuple;
-	AttrNumber	attnum;
+	AttrNumber	attphysnum;
 
 	colname = text_to_cstring(column);
 
 	/*
-	 * We don't use get_attnum() here because it will report that dropped
+	 * We don't use get_attphysnum() here because it will report that dropped
 	 * columns don't exist.  We need to treat dropped columns differently from
 	 * nonexistent columns.
 	 */
@@ -2847,9 +2847,9 @@ convert_column_name(Oid tableoid, text *column)
 		attributeForm = (Form_pg_attribute) GETSTRUCT(attTuple);
 		/* We want to return NULL for dropped columns */
 		if (attributeForm->attisdropped)
-			attnum = InvalidAttrNumber;
+			attphysnum = InvalidAttrNumber;
 		else
-			attnum = attributeForm->attnum;
+			attphysnum = attributeForm->attphysnum;
 		ReleaseSysCache(attTuple);
 	}
 	else
@@ -2870,11 +2870,11 @@ convert_column_name(Oid tableoid, text *column)
 							colname, tablename)));
 		}
 		/* tableoid doesn't exist, so act like attisdropped case */
-		attnum = InvalidAttrNumber;
+		attphysnum = InvalidAttrNumber;
 	}
 
 	pfree(colname);
-	return attnum;
+	return attphysnum;
 }
 
 /*
diff --git a/src/backend/utils/adt/expandedrecord.c b/src/backend/utils/adt/expandedrecord.c
index 3b3e0a9106..18951a40ce 100644
--- a/src/backend/utils/adt/expandedrecord.c
+++ b/src/backend/utils/adt/expandedrecord.c
@@ -1031,7 +1031,7 @@ expanded_record_lookup_field(ExpandedRecordHeader *erh, const char *fieldname,
 		if (namestrcmp(&attr->attname, fieldname) == 0 &&
 			!attr->attisdropped)
 		{
-			finfo->fnumber = attr->attnum;
+			finfo->fnumber = attr->attphysnum;
 			finfo->ftypeid = attr->atttypid;
 			finfo->ftypmod = attr->atttypmod;
 			finfo->fcollation = attr->attcollation;
@@ -1043,7 +1043,7 @@ expanded_record_lookup_field(ExpandedRecordHeader *erh, const char *fieldname,
 	sysattr = SystemAttributeByName(fieldname);
 	if (sysattr != NULL)
 	{
-		finfo->fnumber = sysattr->attnum;
+		finfo->fnumber = sysattr->attphysnum;
 		finfo->ftypeid = sysattr->atttypid;
 		finfo->ftypmod = sysattr->atttypmod;
 		finfo->fcollation = sysattr->attcollation;
diff --git a/src/backend/utils/adt/misc.c b/src/backend/utils/adt/misc.c
index 89690be2ed..5ad1cdc905 100644
--- a/src/backend/utils/adt/misc.c
+++ b/src/backend/utils/adt/misc.c
@@ -636,13 +636,13 @@ Datum
 pg_column_is_updatable(PG_FUNCTION_ARGS)
 {
 	Oid			reloid = PG_GETARG_OID(0);
-	AttrNumber	attnum = PG_GETARG_INT16(1);
-	AttrNumber	col = attnum - FirstLowInvalidHeapAttributeNumber;
+	AttrNumber	attphysnum = PG_GETARG_INT16(1);
+	AttrNumber	col = attphysnum - FirstLowInvalidHeapAttributeNumber;
 	bool		include_triggers = PG_GETARG_BOOL(2);
 	int			events;
 
 	/* System columns are never updatable */
-	if (attnum <= 0)
+	if (attphysnum <= 0)
 		PG_RETURN_BOOL(false);
 
 	events = relation_is_updatable(reloid, NIL, include_triggers,
diff --git a/src/backend/utils/adt/ri_triggers.c b/src/backend/utils/adt/ri_triggers.c
index 51b3fdc9a0..cb28faa420 100644
--- a/src/backend/utils/adt/ri_triggers.c
+++ b/src/backend/utils/adt/ri_triggers.c
@@ -85,9 +85,9 @@
 #define MAX_QUOTED_NAME_LEN  (NAMEDATALEN*2+3)
 #define MAX_QUOTED_REL_NAME_LEN  (MAX_QUOTED_NAME_LEN*2)
 
-#define RIAttName(rel, attnum)	NameStr(*attnumAttName(rel, attnum))
-#define RIAttType(rel, attnum)	attnumTypeId(rel, attnum)
-#define RIAttCollation(rel, attnum) attnumCollationId(rel, attnum)
+#define RIAttName(rel, attphysnum)	NameStr(*attnumAttName(rel, attphysnum))
+#define RIAttType(rel, attphysnum)	attnumTypeId(rel, attphysnum)
+#define RIAttCollation(rel, attphysnum) attnumCollationId(rel, attphysnum)
 
 #define RI_TRIGTYPE_INSERT 1
 #define RI_TRIGTYPE_UPDATE 2
